﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace BastaAdministrator.DataProvider
{
    using System.Threading;

    public class SpeakerProvider : ISpeakerProvider
    {
        public async Task<List<string>> LoadSpeakersAsync(
            Action<int> progress=null,
               CancellationToken token = default(CancellationToken))
        {
                var task= Task.Factory.StartNew(
                    () =>
                    {
                        var list = new List<string>();
                        for (int i = 0; i < 10; i++)
                        {
                            list.Add("Thomas der " + i);
                            if (token.IsCancellationRequested)
                            {
                                break;
                            }
                            if (progress != null)
                            {
                                progress(10 + 10 * i);
                            }
                            Thread.Sleep(500);
                        }
                        return list;
                    });

            var result = await task;
            result.Add("Timo");
            return result;

        }
    }
}
